package org.gcube.portlets.user.geoportaldataentry.client;


/**
 * The Enum ConcessioniFormCardTitle.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
 * 
 * Nov 30, 2020
 */
public enum ConcessioniFormCardTitle {
	
	INFORMAZIONI_DI_PROGETTO("Informazioni", "Informazioni di Progetto", 1, false, null),
	ABSTRACT_RELAZIONE_DI_SCAVO("Abstract Relazione di Scavo", "Abstract Relazione di Scavo", 2, false, null),
	RELAZIONE_DI_SCAVO("Relazione di Scavo", "Relazione di Scavo", 3, false, null),
	IMMAGINI_RAPPRESENTATIVE("Immagini Rappresentative", "Immagini Rappresentative", 4, true, 8),
	POSIZIONAMENTO_DELL_AREA_DI_INDAGINE("Posizionamento", "Posizionamento dell'Area di Indagine", 5, false, null),
	PIANTA_DI_FINE_SCAVO("Pianta di Fine Scavo", "Pianta di Fine Scavo", 6, true, null);
	
	private String key;
	private String title;
	private Integer order;
	private boolean internalRepeatibleForm;
	private Integer maxFormRepeatability;
	
	/**
	 * Instantiates a new concessioni form card title.
	 *
	 * @param key the key
	 * @param title the title
	 * @param order the order
	 * @param internalRepeatibleForm the internal repeatible form
	 * @param maxFormRepeatability the max form repeatability
	 */
	private ConcessioniFormCardTitle(String key, String title, int order, boolean internalRepeatibleForm, Integer maxFormRepeatability) {
		this.key = key;
		this.title = title;
		this.order = order;
		this.internalRepeatibleForm = internalRepeatibleForm;
		this.maxFormRepeatability = maxFormRepeatability;
	}

	/**
	 * Gets the key.
	 *
	 * @return the key
	 */
	public String getKey() {
		return key;
	}

	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * Gets the order.
	 *
	 * @return the order
	 */
	public Integer getOrder() {
		return order;
	}
	
	/**
	 * Checks if is internal repeatible form.
	 *
	 * @return true, if is internal repeatible form
	 */
	public boolean isInternalRepeatibleForm() {
		return internalRepeatibleForm;
	}
	
	/**
	 * Gets the max form repeatability.
	 *
	 * @return the max form repeatability
	 */
	public Integer getMaxFormRepeatability() {
		return maxFormRepeatability;
	}


}
