package org.gcube.portlets.user.geoportaldataentry.client.events;

import java.util.List;

import org.gcube.portlets.user.geoportaldataentry.shared.GeoNaFormDataObject;

import com.google.gwt.event.shared.GwtEvent;

// TODO: Auto-generated Javadoc
/**
 * The Class SaveGeonaDataFormsEvent.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
 * 
 * Oct 20, 2020
 */
public class SaveGeonaDataFormsEvent extends GwtEvent<SaveGeonaDataFormsHandler> {
	
	/** The type. */
	public static Type<SaveGeonaDataFormsHandler> TYPE = new Type<SaveGeonaDataFormsHandler>();
	private List<GeoNaFormDataObject> listGeonaDataForms;


	/**
	 * Instantiates a new save geona data forms event.
	 *
	 * @param listGeonaDataForms the list geona data forms
	 */
	public SaveGeonaDataFormsEvent(List<GeoNaFormDataObject> listGeonaDataForms) {
		this.listGeonaDataForms = listGeonaDataForms;
	}

	/**
	 * Gets the associated type.
	 *
	 * @return the associated type
	 */
	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public Type<SaveGeonaDataFormsHandler> getAssociatedType() {
		return TYPE;
	}

	/**
	 * Dispatch.
	 *
	 * @param handler the handler
	 */
	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#dispatch(com.google.gwt.event.shared.EventHandler)
	 */
	@Override
	protected void dispatch(SaveGeonaDataFormsHandler handler) {
		handler.onSave(this);
	}
	
	public List<GeoNaFormDataObject> getListGeonaDataForms() {
		return listGeonaDataForms;
	}

}
